%global momorel 2
%global srcver 4.2.0
%global srcdate 20040617
%global srcname ntp-stable-%{srcver}a-%{srcdate}

Summary: Synchronizes system time using the Network Time Protocol (NTP).
Name: ntp
Version: %{srcver}
#Release: %{momorel}m
Release: 0.%{srcdate}.%{momorel}m
License: see "COPYRIGHT"
Group: System Environment/Daemons
Source0: http://www.eecis.udel.edu/~ntp/ntp_spool/ntp4/snapshots/ntp-stable/2004/06/%{srcname}.tar.gz
NoSource: 0
Source1: ntp.conf
Source2: ntp.keys
Source3: ntpd.init
Source4: ntpd.sysconfig
Source5: ntpstat-0.2.tgz
Source6: ntp-4.2.0-rh-manpages.tar.gz

# new find-requires
Source7: filter-requires-ntp.sh
%define __find_requires %{SOURCE7}

Patch1: ntp-4.0.99j-vsnprintf.patch
Patch3: ntp-4.0.99m-usegethost.patch

Patch6: ntp-4.2.0-droproot.patch
Patch7: ntp-stable-4.2.0a-20040616-groups.patch

#Patch12: ntp-4.2.0-limit.patch
#Patch13: ntp-4.2.0-loopfilter.patch
Patch15: ntp-4.1.1c-rc3-authkey.patch
Patch16: ntp-4.2.0-md5.patch
Patch17: ntp-4.2.0-genkey3.patch
Patch18: ntp-4.2.0-sbinpath.patch

Patch99: ntp-4.2.0-autofoo.patch

URL: http://www.ntp.org/
PreReq: chkconfig
Prereq: shadow-utils
Requires: libcap
Requires: perl
BuildRequires: perl
BuildPreReq: libcap-devel
Obsoletes: xntp3
BuildRoot: %{_tmppath}/%{name}-%{version}-root
 
%description
The Network Time Protocol (NTP) is used to synchronize a computer's
time with another reference time source. The ntp package contains
utilities and daemons that will synchronize your computer's time to
Coordinated Universal Time (UTC) via the NTP protocol and NTP servers.
The ntp package includes ntpdate (a program for retrieving the date
and time from remote machines via a network) and ntpd (a daemon which
continuously adjusts system time).

Install the ntp package if you need tools for keeping your system's
time synchronized via the NTP protocol.

%prep 
%setup -q -n %{srcname} -a 5 -a 6
%patch3 -p1 -b .usegethost
%patch6 -p1 -b .droproot
%patch7 -p1 -b .groups
# %%patch12 -p1 -b .limit
# %%patch13 -p1 -b .loop
%patch15 -p1 -b .authkey
%patch16 -p1 -b .nomd5lib
%patch17 -p1 -b .md5key
%patch18 -p1 -b .sbinpath
#autoreconf -fi

%patch99 -p1 -b .autofoo
%build

perl -pi -e 's|INSTALL_STRIP_PROGRAM="\\\$\{SHELL\} \\\$\(install_sh\) -c -s|INSTALL_STRIP_PROGRAM="\${SHELL} \$(install_sh) -c|g' configure
# XXX work around for anal ntp configure
%define	_target_platform	%{nil}
export CFLAGS="$RPM_OPT_FLAGS -g -DDEBUG" 
if echo 'int main () { return 0; }' | gcc -pie -fPIE -O2 -xc - -o pietest 2>/dev/null; then
	./pietest && export CFLAGS="$CFLAGS -pie -fPIE"
	rm -f pietest
fi
%configure --sysconfdir=%{_sysconfdir}/ntp --bindir=%{_sbindir} --enable-all-clocks --enable-parse-clocks --with-openssl-libdir=%{_libdir} --enable-linuxcaps
unset CFLAGS
%undefine	_target_platform

make Makefile
for dir in *; do 
	[ -d $dir ] && make -C $dir Makefile || :
done

# Remove -lreadline and -lrt from ntpd/Makefile
# I don't see them used...
perl -pi -e "s|LIBS = -lrt -lreadline|LIBS = |" ntpd/Makefile 

perl -pi -e "s|-lelf||" */Makefile
perl -pi -e "s|-Wcast-qual||" */Makefile
perl -pi -e "s|-Wconversion||" */Makefile

%make
pushd ntpstat-0.2
make
popd

%install
rm -rf %{buildroot}

%makeinstall sysconfdir=%{_sysconfdir}/ntp bindir=%{buildroot}%{_sbindir}

pushd ntpstat-0.2
mkdir -p %{buildroot}/%{_mandir}/man1
mkdir -p %{buildroot}/%{_bindir}

install -m 755 ntpstat %{buildroot}/%{_bindir}/
install -m 644 ntpstat.1 %{buildroot}/%{_mandir}/man1/
popd
pushd man
for i in *.1; do 
	install -m 644 $i %{buildroot}/%{_mandir}/man1/
done

# find . -name \*~ -exec rm -f {} \;

{ cd %{buildroot}

  mkdir -p .%{_sysconfdir}/ntp
  mkdir -p .%{_initscriptdir}
  install -m644 $RPM_SOURCE_DIR/ntp.conf .%{_sysconfdir}/ntp.conf
  mkdir -p .%{_var}/lib/ntp
  echo '0.0' >.%{_var}/lib/ntp/drift
  install -m600 $RPM_SOURCE_DIR/ntp.keys .%{_sysconfdir}/ntp/keys
  touch .%{_sysconfdir}/ntp/step-tickers
  install -m755 $RPM_SOURCE_DIR/ntpd.init .%{_initscriptdir}/ntpd

  mkdir -p .%{_sysconfdir}/sysconfig
  install -m644 %{SOURCE4} .%{_sysconfdir}/sysconfig/ntpd
}

%clean
rm -rf %{buildroot}

%pre
/usr/sbin/groupadd -g 38 ntp  2> /dev/null || :
/usr/sbin/useradd -u 38 -g 38 -s /sbin/nologin -M -r -d /etc/ntp ntp 2>/dev/null || :

%post
/sbin/chkconfig --add ntpd
if [ "$1" -ge "1" ]; then
  grep %{_sysconfdir}/ntp/drift %{_sysconfdir}/ntp.conf > /dev/null 2>&1
  olddrift=$?
  if [ $olddrift -eq 0 ]; then
    service ntpd status > /dev/null 2>&1
    wasrunning=$?
    # let ntp save the actual drift
    [ $wasrunning -eq 0 ] && service ntpd stop > /dev/null 2>&1
    # copy the driftfile to the new location
    [ -f %{_sysconfdir}/ntp/drift ] \
      && cp %{_sysconfdir}/ntp/drift %{_var}/lib/ntp/drift
    # change the path in the config file
    sed -e 's#%{_sysconfdir}/ntp/drift#%{_var}/lib/ntp/drift#g' \
      %{_sysconfdir}/ntp.conf > %{_sysconfdir}/ntp.conf.rpmupdate \
      && mv %{_sysconfdir}/ntp.conf.rpmupdate %{_sysconfdir}/ntp.conf 
    # remove the temp file
    rm -f %{_sysconfdir}/ntp.conf.rpmupdate
    # start ntp if it was running previously
    [ $wasrunning -eq 0 ] && service ntpd start > /dev/null 2>&1
  fi
fi

%preun
if [ $1 = 0 ]; then
    service ntpd stop > /dev/null 2>&1
    /sbin/chkconfig --del ntpd
fi

%postun
if [ "$1" -ge "1" ]; then
  service ntpd condrestart > /dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc html/* NEWS TODO 
%{_sbindir}/ntp-wait
%{_sbindir}/ntptrace
%{_sbindir}/ntp-keygen
%{_sbindir}/ntpd
%{_sbindir}/ntpdate
%{_sbindir}/ntpdc
%{_sbindir}/ntpq
%{_sbindir}/ntptime
%{_sbindir}/tickadj
%config			%{_initscriptdir}/ntpd
%config(noreplace)	%{_sysconfdir}/sysconfig/ntpd
%config(noreplace)	%{_sysconfdir}/ntp.conf
%dir 	%{_sysconfdir}/ntp
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/ntp/step-tickers
%config(noreplace) %{_sysconfdir}/ntp/keys
%dir	%attr(-,ntp,ntp)   %{_var}/lib/ntp
%config(noreplace) %attr(644,ntp,ntp) %verify(not md5 size mtime) %{_var}/lib/ntp/drift
%{_mandir}/man1/*
%{_bindir}/ntpstat

%changelog
* Mon Apr 11 2005 Toru Hoshina <t@momonga-linux.org>
- (4.2.0-0.20040619.2m)
- revised ntp.conf.

* Sun Feb 27 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.2.0-0.20040619.1m)
- update to 4.2.0 daily version

* Tue May  4 2004 Toru Hoshina <t@momonga-linux.org>
- (4.1.2-4m)
- rebuild against ncurses 5.3.

* Wed Nov  5 2003 zunda <zunda at freeshell.org>
- (4.1.2-3m)
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)

* Sun Oct 19 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (4.1.2-2m)
- avoid conflict of macro name (CONFIG_PHONE against kernel config)

* Tue Jul 29 2003 Hiroyuki KOGA <kuma@momonga-linux.org>
- (4.1.2-1m)
- update to 4.1.2

* Sat Apr 12 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (4.1.1b-2m)
- change Source0 URI

* Sun Dec 29 2002 Kazuhiko <kazuhiko@fdiary.net>
- (4.1.1b-1m)

* Sun May 19 2002 Tadataka Yoshikawa <yosshy@kondara.org>
- (4.1.1a-2k)
- update to 4.1.1a

* Wed Mar 16 2002 YAMAGUCHI Kenji <yamk@kondara.org>
- (4.1.1-2k)
- update to 4.1.1
- rework ntp-4.1.1-droproot.patch

* Tue Oct 22 2001 Toru Hoshina <t@kondara.org>
- (4.1.0-2k)
- merge from rawhide. [4.1.0-4]

* Wed Sep 05 2001 Harald Hoyer <harald@redhat.de> 4.1.0-4
- fixed #53184

* Tue Sep 04 2001 Harald Hoyer <harald@redhat.de> 4.1.0-3
- fixed #53089 /bin/nologin -> /sbin/nologin

* Fri Aug 31 2001 Harald Hoyer <harald@redhat.de> 4.1.0-2
- fixed #50247 thx to <enrico.scholz@informatik.tu-chemnitz.de>

* Thu Aug 30 2001 Harald Hoyer <harald@redhat.de> 4.1.0-1
- wow, how stupid can a man be ;).. fixed #50698 
- updated to 4.1.0 (changes are small and in non-critical regions)

* Wed Aug 29 2001 Harald Hoyer <harald@redhat.de> 4.0.99mrc2-5
- really, really :) fixed #52763, #50698 and #50526

* Mon Aug 27 2001 Tim Powers <timp@redhat.com> 4.0.99mrc2-4
- rebuilt against newer libcap
- Copyright -> license

* Wed Jul 25 2001 Harald Hoyer <harald@redhat.com> 4.0.99mrc2-3
- integrated droproot patch (#35653)
- removed librt and libreadline dependency 

* Sat Jul  7 2001 Tim Powers <timp@redhat.com>
- don't build build sgid root dirs

* Mon Jun 18 2001 Harald Hoyer <harald@redhat.de>
- new snapshot
- removed typos and security patch (already there)
- commented multicastclient in config file

* Thu Jun 07 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- call libtoolize to compile on newer archs

* Mon Apr  9 2001 Preston Brown <pbrown@redhat.com>
- remove ghost files make RHN happy
- modify initscript to match accordingly

* Fri Apr  6 2001 Pekka Savola <pekkas@netcore.fi>
- Add the remote root exploit patch (based on ntp-hackers).
- Enhance droproot patch (more documentation, etc.) <Jarno.Huuskonen@uku.fi>
- Tweak the droproot patch to include sys/prctl.h, not linux/prctl.h
(implicit declarations)
- Remote groupdel commands, shouldn't be needed.
- Removed -Wcast-qual and -Wconversion due to excessive warnings (hackish).
- Make ntp compilable with both glibc 2.1 and 2.2.x (very dirty hack)
- Add /etc/sysconfig/ntpd which drops root privs by default

* Thu Apr  5 2001 Preston Brown <pbrown@redhat.com>
- security patch for ntpd

* Mon Mar 26 2001 Preston Brown <pbrown@redhat.com>
- don't run configure macro twice (#32804)

* Sun Mar 25 2001 Pekka Savola <pekkas@netcore.fi>
- require/buildprereq libcap/libcap-devel
- use 'ntp' user, tune the pre/post scripts, %%files
- add $OPTIONS to the init script

* Tue Mar 20 2001 Jarno Huuskonen <Jarno.Huuskonen@uku.fi>
- droproot/caps patch
- add ntpd user in pre
- make /etc/ntp ntpd writable

* Mon Mar  5 2001 Preston Brown <pbrown@redhat.com>
- allow comments in /etc/ntp/step-tickers file (#28786).
- need patch0 (glibc patch) on ia64 too

* Tue Feb 13 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- also set prog=ntpd in initscript

* Tue Feb 13 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- use "$prog" instead of "$0" for the init script

* Thu Feb  8 2001 Preston Brown <pbrown@redhat.com>
- i18n-neutral .init script (#26525)

* Tue Feb  6 2001 Preston Brown <pbrown@redhat.com>
- use gethostbyname on addresses in /etc/ntp.conf for ntptime command (#26250)

* Mon Feb  5 2001 Preston Brown <pbrown@redhat.com>
- start earlier and stop later (#23530)

* Mon Feb  5 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- i18nize init script (#26078)

* Sat Jan  6 2001 Jeff Johnson <jbj@redhat.com>
- typo in ntp.conf (#23173).

* Mon Dec 11 2000 Karsten Hopp <karsten@redhat.de>
- rebuilt to fix permissions of /usr/share/doc/ntp-xxx

* Thu Nov  2 2000 Jeff Johnson <jbj@redhat.com>
- correct mis-spellings in ntpq.htm (#20007).

* Thu Oct 19 2000 Jeff Johnson <jbj@redhat.com>
- add %ghost /etc/ntp/drift (#15222).

* Wed Oct 18 2000 Jeff Johnson <jbj@redhat.com>
- comment out default values for keys, warn about starting with -A (#19316).
- take out -A from ntpd startup as well.
- update to 4.0.99k.

* Wed Aug 23 2000 Jeff Johnson <jbj@redhat.com>
- use vsnprintf rather than vsprintf (#16676).

* Mon Aug 14 2000 Jeff Johnson <jbj@redhat.com>
- remove Conflicts: so that the installer is happy.

* Tue Jul 25 2000 Jeff Johnson <jbj@redhat.com>
- workaround glibc-2.1.90 lossage for now.

* Thu Jul 20 2000 Bill Nottingham <notting@redhat.com>
- move initscript back

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jun 26 2000 Preston Brown <pbrown@redhat.com>
- move and update init script, update post/preun/postun scripts

* Wed Jun 21 2000 Preston Brown <pbrown@redhat.com>
- noreplace ntp.conf,keys files

* Mon Jun 12 2000 Jeff Johnson <jbj@redhat.com>
- Create 4.0.99j package.
- FHS packaging.
